image: docker:19.03.1

services:
  - docker:19.03.1-dind

variables:
  # Use TLS https://docs.gitlab.com/ee/ci/docker/using_docker_build.html#tls-enabled
  DOCKER_HOST: tcp://docker:2376
  DOCKER_TLS_CERTDIR: "/certs"

before_script:
  - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY

.build: &build
  - echo "Creating docker image with tag $IMAGE_TAG."
  - docker pull $CI_REGISTRY_IMAGE:$IMAGE_CACHE || true
  - DOCKER_BUILDKIT=1 docker build --cache-from $CI_REGISTRY_IMAGE:$IMAGE_CACHE --tag $CI_REGISTRY_IMAGE:$IMAGE_TAG https://raw.githubusercontent.com/stephenh/ts-proto/main/protoc.Dockerfile
  - docker push $CI_REGISTRY_IMAGE:$IMAGE_TAG

build:commit:
  stage: build
  only:
    - branches
  except:
    - /^main$/
  script:
    - IMAGE_CACHE=latest
    - IMAGE_TAG=$CI_COMMIT_SHA
    - *build

build:tag:
  stage: build
  only:
    - tags
  script:
    - IMAGE_CACHE=latest
    - IMAGE_TAG=$CI_COMMIT_TAG
    - *build


build:latest:
  stage: build
  only:
    - main
  script:
    - IMAGE_CACHE=latest
    - IMAGE_TAG=latest
    - *build


after_script:
  - docker logout ${CI_REGISTRY}
